# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define namedversion %{version}

%define section free

Name:           google-guice
Version:        2.0
Release:        3%{?dist}
Epoch:          0
Summary:        Dependency Injection Framework
Group:          Development/Java
License:        ASL 2.0
URL:            http://code.google.com/p/google-guice/
# svn export http://google-guice.googlecode.com/svn/tags/2.0 google-guice-2.0 && tar cjf google-guice-2.0.tar.bz2 google-guice-2.0
# Exported revision 1465.
Source0:        google-guice-2.0.tar.bz2
Source1:        %{name}-jpp-depmap.xml
Patch0:         google-guice-pom.patch
Patch1:         servlet-build-xml.patch
Patch2:         spring-build-xml.patch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
Requires:       aopalliance >= 0:1.0
Requires:       cglib >= 0:2.2
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
Requires:       objectweb-asm >= 0:3.1
BuildRequires:  aopalliance >= 0:1.0
#BuildRequires:  apache-commons-parent
BuildRequires:  cglib >= 0:2.2
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  junit
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-doxia
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  servlet_2_5_api
BuildRequires:  jarjar
BuildRequires:  spring2-beans
BuildRequires:  freemarker
BuildRequires:  jetty6
BuildRequires:  jsp_2_1_api
BuildRequires:  ognl
#BuildRequires:  xwork
%if %with repolib
BuildRequires:  maven2-plugin-deploy
%endif
BuildRequires:  objectweb-asm >= 0:3.1
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Put simply, Guice alleviates the need for factories and the
use of new in your Java code. Think of Guice's @Inject as 
the new new. You will still need to write factories in some
cases, but your code will not depend directly on them. Your
code will be easier to change, unit test and reuse in other
contexts.

Guice embraces Java's type safe nature, especially when it 
comes to features introduced in Java 5 such as generics and
annotations. You might think of Guice as filling in missing
features for core Java. Ideally, the language itself would 
provide most of the same features, but until such a 
language comes along, we have Guice.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p1 -b .sav2
for j in $(find . -name "*.jar"); do
    mv $j $j.no
done
mkdir -p src/main/java
mv src/com src/main/java
mkdir -p build/dist
#BUILD/google-guice-2.0/lib/aopalliance.jar.no
ln -sf $(build-classpath aopalliance) lib/aopalliance.jar
#BUILD/google-guice-2.0/lib/build/asm-3.1.jar.no
ln -sf $(build-classpath objectweb-asm/asm) lib/build/asm-3.1.jar
#BUILD/google-guice-2.0/lib/build/bnd-0.0.305.jar.no
#ln -sf $(build-classpath aqute-bndlib) lib/build/bnd-0.0.305.jar
mv lib/build/bnd-0.0.305.jar.no lib/build/bnd-0.0.305.jar
#BUILD/google-guice-2.0/lib/build/cglib-2.2.1-snapshot.jar.no
ln -sf $(build-classpath cglib) lib/build/cglib-2.2.1-snapshot.jar
#BUILD/google-guice-2.0/lib/build/commons-logging-1.0.4.jar.no
ln -sf $(build-classpath commons-logging) lib/build/commons-logging-1.0.4.jar
#BUILD/google-guice-2.0/lib/build/easymock.jar.no
ln -sf $(build-classpath easymock) lib/build/easymock.jar
#BUILD/google-guice-2.0/lib/build/jarjar-1.0rc8.jar.no
ln -sf $(build-classpath jarjar) lib/build/jarjar-1.0rc8.jar
#BUILD/google-guice-2.0/lib/build/junit.jar.no
ln -sf $(build-classpath junit) lib/build/junit.jar
#BUILD/google-guice-2.0/lib/build/munge.jar.no

#BUILD/google-guice-2.0/lib/build/safesax.jar.no

#BUILD/google-guice-2.0/lib/build/spring-beans.jar.no
ln -sf $(build-classpath spring2/beans) lib/build/spring-beans.jar
#BUILD/google-guice-2.0/lib/build/spring-core.jar.no
ln -sf $(build-classpath spring2/core) lib/build/spring-core.jar
#BUILD/google-guice-2.0/servlet/lib/build/servlet-api-2.5.jar.no
ln -sf $(build-classpath servlet_2_5_api) servlet/lib/build/servlet-api-2.5.jar
#BUILD/google-guice-2.0/struts2/lib/ant-1.6.5.jar.no
ln -sf $(build-classpath ant) struts2/lib/ant-1.6.5.jar
#BUILD/google-guice-2.0/struts2/lib/commons-logging-1.0.4.jar.no
ln -sf $(build-classpath commons-logging) struts2/lib/commons-logging-1.0.4.jar
#BUILD/google-guice-2.0/struts2/lib/core-3.1.1.jar.no
ln -sf $(build-classpath ecj3) struts2/lib/core-3.1.1.jar
#BUILD/google-guice-2.0/struts2/lib/freemarker-2.3.8.jar.no
ln -sf $(build-classpath freemarker) struts2/lib/freemarker-2.3.8.jar
#BUILD/google-guice-2.0/struts2/lib/jetty-6.1.0.jar.no
ln -sf $(build-classpath jetty6/jetty6) struts2/lib/jetty-6.1.0.jar
#BUILD/google-guice-2.0/struts2/lib/jetty-util-6.1.0.jar.no
ln -sf $(build-classpath jetty6/jetty6-util) struts2/lib/jetty-util-6.1.0.jar
#BUILD/google-guice-2.0/struts2/lib/jsp-2.1.jar.no
#ln -sf $(build-classpath jetty6/jsp-2.1/jsp-2.1-jetty) struts2/lib/jsp-2.1.jar
ln -sf $(build-classpath jsp_2_1_api) struts2/lib/jsp-2.1.jar
#BUILD/google-guice-2.0/struts2/lib/jsp-api-2.1.jar.no
ln -sf $(build-classpath jsp_2_1_api) struts2/lib/jsp-api-2.1.jar
#BUILD/google-guice-2.0/struts2/lib/ognl-2.6.9.jar.no
ln -sf $(build-classpath ognl) struts2/lib/ognl-2.6.9.jar
#BUILD/google-guice-2.0/struts2/lib/servlet-api-2.5.jar.no
ln -sf $(build-classpath servlet_2_5_api) struts2/lib/servlet-api-2.5.jar
#BUILD/google-guice-2.0/struts2/lib/struts2-api-2.0.5.jar.no
#BUILD/google-guice-2.0/struts2/lib/struts2-core-2.0.5.jar.no
#BUILD/google-guice-2.0/struts2/lib/xwork-2.0.0.jar.no
#ln -sf $(build-classpath xwork) struts2/lib/xwork-2.0.0.jar
mv struts2/lib/xwork-2.0.0.jar.no struts2/lib/xwork-2.0.0.jar

%build
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
%if 0
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=oss-releases::default::file://$(pwd)/maven2-brew \
%endif
        install javadoc:javadoc

export CLASSPATH=$(build-classpath jarjar servlet_2_5_api spring2/beans):$(pwd)/target/guice-%{version}.jar
for m in servlet \
         spring; do
    pushd $m
    ant
    popd
done

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
# FIXME: names should be guice, not google-guice!!!
install -m 644 target/guice-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
install -m 644 servlet/build/guice-servlet-%{version}.jar %{buildroot}%{_javadir}/%{name}-servlet-%{namedversion}.jar
install -m 644 spring/build/guice-spring-%{version}.jar %{buildroot}%{_javadir}/%{name}-spring-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do ln -s ${jar} `/bin/echo ${jar} | sed "s|-%{namedversion}||g"`; done)

# poms
mkdir -p %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap com.google.inject guice %{namedversion} JPP %{name}
%add_to_maven_depmap org.guiceyfruit guice-servlet %{namedversion} JPP %{name}-servlet

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=`pwd`/.m2/repository -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom -Dfile=%{buildroot}%{_javadir}/%{name}-%{version}.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*/
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Nov 16 2012 David Walluck <dwalluck@redhat.com> 0:2.0-3
- don't replace bundled bnd
- fix deploy command
- fix repolib files
- lower objectweb-asm version
- don't requires common-parent
- use javadoc:javadoc, not javadoc:aggregate
- maven-doxia{,-sitetools} should be requires by maven-javadoc-plugin 
- add missing servlet_2_5_api
- add missing jarjar
- add spring2-beans
- add back patches from weli
- add missing BuildRequires

* Thu May 26 2011 Ralph Apel <r.apel@r-apel.de> 0:2.0-2
- Add -servlet and -spring artifacts

* Thu Dec 23 2010 David Walluck <dwalluck@redhat.com> 0:2.0-1
- 2.0

* Mon Aug 11 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.RC2.1.jpp5
- Initial release
